CREATE OR REPLACE
TRIGGER OPERRESP_SOLISERV
BEFORE INSERT OR UPDATE ON SOLISERV FOR EACH ROW
DECLARE
   V_CDOPERRESP OPERADOR.CDOPERADOR%TYPE;
   V_CDSETOR SOLISERV.CDSETOR%TYPE;
   V_NRCORTEXOBSO FLOAT;
   V_NRCORFUNOBSO FLOAT;
   V_COUNT_OBS NUMBER;
BEGIN
   IF INSERTING THEN
      :NEW.CDOPERRESP := RESPONSAVEL_POR_SISTEMA(:NEW.CDPRODCOMP);
      IF (:NEW.CDASSUNTO = '00102') THEN /* ERRO EM SISTEMA - SUPORTE (ABERTA COM ASSUNTO ERRADO) */
         :NEW.CDASSUNTO := '00010'; /* ERRO LEVE - MANUTENO */
      END IF;
      IF (:NEW.CDASSUNTO = '00124') THEN /* EVOLUO TECNOLGICA (ABERTA COM ASSUNTO ERRADO) */
         :NEW.CDASSUNTO := '00013'; /* EVOLUO TECNOLGICA - MANUTENO */
      END IF;
      IF (:NEW.CDASSUNTO = '00012') OR /* LEGISLAO - MANUTENO */
         (:NEW.CDASSUNTO = '00013') OR /* EVOLUO TECNOLGICA - MANUTENO */
         (:NEW.CDASSUNTO = '00014') OR /* EVOLUO TECNOLGICA - TEKNISA */
         (:NEW.CDASSUNTO = '00021') OR /* CUSTOMIZAO - ESPECFICO DO CLIENTE */
         (:NEW.CDASSUNTO = '00022') OR /* EVOLUO EM OUTRAS VERSES */
         (:NEW.CDASSUNTO = '00027') OR /* ATUALIZAO DE LEGISLAO */
         (:NEW.CDASSUNTO = '00028') OR /* SIMPLIFICAO DO PRODUTO */
         (:NEW.CDASSUNTO = '00041') THEN /* DESENVOLVIMENTO DE SISTEMA NOVO */
         :NEW.CDFASETRAM := '110'; /* ANLISE DO GERENTE DE PRODUTO */
      END IF;
      IF (:NEW.CDASSUNTO = '00015') THEN /* CORREO DE ERROS EM OUTRAS VERSES */
         :NEW.CDFASETRAM := '265'; /* VERIFICAO DE ERRO */
      END IF;
      IF (:NEW.CDASSUNTO = '00010') OR /* ERRO LEVE - MANUTENO */
         (:NEW.CDASSUNTO = '00011') OR /* ERRO GRAVE - MANUTENO */
         (:NEW.CDASSUNTO = '00016') OR /* PERFORMANCE - MANUTENO */
         (:NEW.CDASSUNTO = '00104') THEN /* PERFORMANCE */
         :NEW.CDOPERRESP := '000000000993'; /* TESTE DE ENTRADA */
         :NEW.CDFASETRAM := '007'; /* TESTE DE ENTRADA */
      END IF;
      IF (:NEW.CDASSUNTO = '02010') THEN /* GERNCIA DE PRODUTO */
         :NEW.CDFASETRAM := '790'; /* GERNCIA DE PRODUTO */
      END IF;
   END IF;
   /* APAGA O PROJETO QUANDO RETORNA APROVADA E ENCAMINHA PARA O RESPONSVEL */
   IF (:NEW.CDFASETRAM = '266' AND :OLD.CDFASETRAM <> '266') OR
      (:NEW.CDFASETRAM = '066' AND :OLD.CDFASETRAM <> '066') THEN
      :NEW.CDOPERRESP := RESPONSAVEL_POR_SISTEMA(:NEW.CDPRODCOMP);
      DELETE FROM SOLIBASELINE
       WHERE CDFILIAL = :NEW.CDFILIAL
         AND NRSOLISERV = :NEW.NRSOLISERV;
   END IF;
   IF UPDATING AND :OLD.CDFASETRAM = '110' AND :NEW.CDFASETRAM IN ('019', '219', '419') THEN
      BEGIN
         INSERT INTO SOLGRACORDOPROJ
            (CDGRUPOPROJ, CDFILIAL, NRSOLISERV, IDSOLIGRPROJ,
             DTINCSOLIGRPROJ, CDOPERINCLUSAO, CDJUSTIFICATIVA,
             DSANAVIAGRPROJ, NRORG, DTINCLUSAO, NRORGINCLUSAO)
         VALUES
            ('PROJGERESP', :NEW.CDFILIAL, :NEW.NRSOLISERV, 'I',
             SYSDATE, '000000000991', '00005',
            'Especificar', 1, SYSDATE, 1);
      EXCEPTION
         WHEN OTHERS THEN NULL;
      END;
   END IF;
   IF (:NEW.CDFASETRAM = '010') THEN
      :NEW.CDOPERRESP := RESPONSAVEL_POR_SISTEMA(:NEW.CDPRODCOMP);
   END IF;   
   IF (:NEW.CDASSUNTO = '06000') OR (:NEW.CDPRODGRUP = '0000001386') THEN /* Administrao de rede */
      :NEW.CDASSUNTO := '06000';
      IF (:NEW.CDPRODGRUP <> '0000001386') THEN
         :NEW.CDPRODGRUP := '0000001386';
         :NEW.CDPRODCOMP := '0000001387';
      END IF;
      IF INSERTING THEN 
         :NEW.CDOPERRESP := RESPONSAVEL_POR_SISTEMA(:NEW.CDPRODCOMP);
         :NEW.CDFASETRAM := '317';
      END IF;
   END IF;
   IF (:NEW.CDASSUNTO = '05000') OR (:NEW.CDPRODGRUP = '0000001207') THEN /* Comunicao de mercado */
      :NEW.CDASSUNTO := '05000';
      IF (:NEW.CDPRODGRUP <> '0000001207') THEN
         :NEW.CDPRODGRUP := '0000001207';
         :NEW.CDPRODCOMP := '0000001208';
      END IF;
      IF INSERTING THEN
         :NEW.CDOPERRESP := RESPONSAVEL_POR_SISTEMA(:NEW.CDPRODCOMP);
         :NEW.CDFASETRAM := '017';
      END IF;
   END IF;
   IF (:NEW.CDASSUNTO = '02010') AND (:NEW.DSREFESOLI <> :OLD.DSREFESOLI) THEN /* GERNCIA DE PRODUTO */
      UPDATE TAREFA
         SET DSREFETAREFA = :NEW.DSREFESOLI
       WHERE CDFILIAL = :NEW.CDFILIAL
         AND NRSOLISERV = :NEW.NRSOLISERV
         AND NRORG = :NEW.NRORG;
   END IF;
   -- ##########################################################
   -- REGISTRA O SETOR DO RESPONSVEL PELO SUB-PRODUTO (SISTEMA)
   -- ##########################################################
   IF :NEW.CDSETOR IS NULL THEN
      IF :NEW.CDPRODGRUP = '0000001386' OR     /* ADMINISTRAO DE REDES */
         :NEW.CDPRODGRUP = '0000001207' THEN   /* COMUNICAO PARA O MERCADO */
         SELECT MAX(CDSETOR)
           INTO :NEW.CDSETOR
           FROM OPERADOR
          WHERE CDOPERADOR = :NEW.CDOPERSOLI;
      ELSE   
         SELECT MAX(CDSETOR)
           INTO :NEW.CDSETOR
           FROM OPERADOR
          WHERE CDOPERADOR = RESPONSAVEL_POR_SISTEMA(:NEW.CDPRODCOMP);
      END IF;
   END IF;   
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('OPERRESP_SOLISERV','4.11.046'); END;
/