/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODCMPFILI                                              */
/* Tabela : PRODCMPFILI                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PRODCMPFILI'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PRODCMPFILI
GO

CREATE TRIGGER DTULTATU_PRODCMPFILI
ON PRODCMPFILI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRODCMPFILI', CDFILIAL, 'CDFILIAL=' + CDFILIAL + ';'+
                                                'CDPRODUTO='+ CDPRODUTO+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRODCMPFILI
      SET DTULTATUPCMP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PRODCMPFILI.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0)) AND
            (ISNULL(PRODCMPFILI.CDFILIAL,0)  = ISNULL(INSERTED.CDFILIAL,0));
   END;
END;
GO

